clc;
clear all;

%----------------------------------------------------------------------
%  This file replicates the results of Section 2.1 of the paper 
%  "Crude Substitution: the Cyclical dynamics of Oil prices and the
%  Skill premium"  (written by Pedro Silos)
%----------------------------------------------------------------------

global Ndata data weight m1 m2 m12 m11 m22 dimv rhos detind

for detind=2:2; % Loops over three detrending procedures (1=Exp. Detrend,
                % 2=BP detrend, 3=HP Detrend)
    
load var_data.txt;
data=log(var_data(:,3:4));
sample = 2 ; % determines size of sample. 1=long, 2=short

if (sample==1) 
begin = 1; 
else
begin = 17;
end

endsmpl = rows(data); 

data = [data(1:rows(data),1) data(1:rows(data),2)]; 
 
xdata=1:1:rows(data); 

if (detind==1) 
b=regress(data(:,1),[ones(rows(data),1) xdata']);
yfit1 = b(1) + b(2)*xdata';

b=regress(data(:,2),[ones(rows(data),1) xdata']);
yfit2 = b(1) + b(2)*xdata';

dtrend1 = data(:,1)-yfit1;
dtrend2 = data(:,2)-yfit2;

data = [dtrend1 dtrend2];
data = data(begin:endsmpl,:);
elseif (detind==3) ;
data = [data(:,1)-hpfilter(data(:,1),100) data(:,2)-hpfilter(data(:,2),100)];    
data = data(begin:endsmpl,:);    
else
data = [bpass(data(:,1),5,35 ) bpass(data(:,2),5,35)];
data = data(begin:endsmpl,:);    
end

Ndata = rows(data);
 
% compute some sample moments

m1 = mean(data(:,1)); % sample mean for variable 1
m2 = mean(data(:,2)); % sample mean for variable 2
m12 = mean(data(:,2).*data(:,1)); % sample mean of cross 
                                  % product between variables 1 and 2
m11 = mean(data(:,1).^2); % second moment variable 1
m22 = mean(data(:,2).^2); % second moment variable 2 

% This part calls some programs to compute the standard error of the
% correlation coefficient.

std_gmm_corr
 
end
 
 