
clc;
clear all;

global Ndata data weight m1 m2 m12 m11 m22 dimv rhos detind

% Estimation of "\nu" by OLS (See section3)
load dataforestimatingnu.txt;
nudata = dataforestimatingnu;
y = nudata(:,1);
x = nudata(:,2);
[b_nu,bint,res]=regress(y,x);  % b_nu is beta
se = sum(res.^2)/(rows(y));
sb = sqrt( se*inv(x'*x) ); % std error of beta

load data1963_2004.txt;
 
data=data1963_2004; 

ToTdata=data;
T = rows(ToTdata);
 

% get covariates

covdata=[ToTdata(2:T,3) ToTdata(2:T,2) ToTdata(2:T,6) ToTdata(2:T,5) ToTdata(1:T-1,4) ToTdata(2:T,10)]; 
 

T=rows(covdata);


load Paramdraw
load H0draw

burnin = 200000;
% Discard the first 20% of draws
Paramdrawnew = Paramdraw(burnin+1:rows(Paramdraw),:);
oilprices = log(data(2:rows(data),12)); %load data on oil prices (lose one obs)

% some storage stuff
corrdt = zeros(rows(Paramdrawnew),1);
corrbp = zeros(rows(Paramdrawnew),1);
corrhp = zeros(rows(Paramdrawnew),1);
 

time = 1:1:rows(covdata);
time = time';
for i=1:rows(Paramdrawnew);
    param = Paramdrawnew(i,:);
    param(12) = randn(1,1)*sb - b_nu;
     xdata = [mean(H0draw(burnin+1:rows(Paramdraw),1))*ones(rows(covdata),1) mean(H0draw(burnin+1:rows(Paramdraw),2))*ones(rows(covdata),1)];
    spmodel = log(measfun2(param,covdata,xdata)); 
    gdp_model = log(output_oil(param,covdata,xdata));
    z=corrcoef(bpass(spmodel,3,35),bpass(oilprices,3,35));
    corrbp(i) = z(1,2);
    z=corrcoef(bpass(spmodel,3,35),bpass(gdp_model,3,35));
    corrbp(i) = z(1,2);
    z=corrcoef(spmodel-hpfilter(spmodel,100),oilprices-hpfilter(oilprices,100));
    corrhp(i) = z(1,2);
    b=regress(spmodel,[ones(rows(xdata),1) time]);
    spdt = spmodel-b(1)-b(2)*time;
    b=regress(oilprices,[ones(rows(xdata),1) time]);
    opdt = oilprices-b(1)-b(2)*time;
    b=regress(gdp_model,[ones(rows(xdata),1) time]);
    gdpdt = gdp_model-b(1)-b(2)*time;
    z=corrcoef(spdt,opdt);
    corrdt(i) =z(1,2);    
    i
end

% Display some correlations
disp('Corr. between Oil prices and the skill premium (post draws)')
disp('Exp. Detrend')
mean(corrdt)
std(corrdt)
disp('BP filt')
mean(corrbp)
std(corrbp)
disp('HP Filt')
mean(corrhp)
std(corrhp)

param = mean(Paramdrawnew);
for detind=1:3
spmodel = log(measfun2(param,covdata,xdata)); 
data = [ spmodel oilprices];
data = [data(1:rows(data),1) data(1:rows(data),2)]; 
 
tdata=1:1:rows(data); 

if (detind==1) 
b=regress(data(:,1),[ones(rows(data),1) tdata']);
yfit1 = b(1) + b(2)*tdata';

b=regress(data(:,2),[ones(rows(data),1) tdata']);
yfit2 = b(1) + b(2)*tdata';

dtrend1 = data(:,1)-yfit1;
dtrend2 = data(:,2)-yfit2;

data = [dtrend1 dtrend2];
data = data(1:rows(data),:);
elseif (detind==3) ;
data = [data(:,1)-hpfilter(data(:,1),100) data(:,2)-hpfilter(data(:,2),100)];    
data = data(1:rows(data),:);    
else
data = [bpass(data(:,1),5,35 ) bpass(data(:,2),5,35)];
data = data(1:rows(data),:);    
end

Ndata = rows(data);
m1 = mean(data(:,1)); % sample mean for variable 1
m2 = mean(data(:,2)); % sample mean for variable 2
m12 = mean(data(:,2).*data(:,1)); % sample mean of cross 
                                  % product between variables 1 and 2
m11 = mean(data(:,1).^2); % second moment variable 1
m22 = mean(data(:,2).^2); % second moment variable 2 

std_gmm_corr
end
