
function ratio_cc=ratiostd_gmm


global Ndata data weight m1 m2 m11 m22 dimv rhos

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


rhos = std(data(:,1))/std(data(:,2));

dimx = 4; % dimension of the vector of parameters. 
dimv = 4; % dimension of the vector of moments
weight = eye(dimv);
u = zeros(Ndata,dimv);
 
x0 = 0.5*ones(dimx,1);
 
for i=1:10
   for j=1:10
x0 = fminsearch('gmm_ratio',x0);
   end
u(:,1) = data(:,1) - x0(1);
u(:,2) = data(:,2) - x0(2);
u(:,3) = data(:,1).*data(:,1) - x0(3);
u(:,4) = data(:,2).*data(:,2) - x0(4);
weight = inv((1/Ndata)*(u'*u));
end

% Asymptotic variance;

% compute jacobian (matrix of partial derivatives of gmm1 wrt parameters)
% 
 J = zeros(dimv,dimx);
 eps = 1d-8;
% 
 for i=1:dimx
 evec = zeros(dimx,1);
 evec(i) = eps;
 x=x0+evec;
 J(:,i) = ((gmm1_J_ratio(x)-gmm1_J_ratio(x0))./eps)';
 end
 
 
 % The asymptotic covariance matrix is:
 
 COVAR = inv(J'*weight*J)/Ndata;
 
 COVAR(1,1);
 std(data(:,1))^2/Ndata;
 
 x = x0;
 
 % Now compute the asymptotic covariance of the ratio
 % Compute the gradient of the covariance with respect to 
 % the parameters. 
 
 grad_cf = zeros(dimx,1);
 
 for i=1:dimx;
     evec = zeros(dimx,1);
     evec(i) = eps;
     grad_cf(i) = (ratiofun(x0+evec)-ratiofun(x0))/eps;
 end
 
 
 %exact gradient
 
 g=zeros(dimv,1);
 g(1) = -2*x(1)/(x(4)-x(2)*x(2));
 g(2) = ((x(3)-x(1)*x(1))*2*(x(2)))/(x(4)-x(2)*x(2))^2;
 g(3) = 1/(x(4)-x(2)*x(2));
 g(4) = -(x(3)-x(1)*x(1))/(x(4)-x(2)*x(2))^2;
 
% Variance of correlation coefficient:
var_cc = (grad_cf'*inv(weight)*grad_cf)/Ndata;
% Standard deviation of correlation coefficient:
disp('Ratio of Standard Deviations is:')
disp(rhos);
std_cc = sqrt(var_cc);
disp('Std. Error of the Ratio is:');
disp(std_cc); 
disp('95% CI')
disp([rhos-std_cc*1.96 rhos+std_cc*1.96]);



