clc;
clear all;

%----------------------------------------------------------------------
%  This file replicates the results of Section 3, Table 6, First Column, of the paper 
%  "Crude Substitution: the Cyclical dynamics of Oil prices and the
%  Skill premium"  (written by Pedro Silos)
%----------------------------------------------------------------------

global Ndata data weight m1 m2 m12 m11 m22 dimv rhos detind
 
    
load var_data.txt;
% column 2 is GDP, column 4 is skill premium

 
for i=1:3
    
     if (i==1) 
data=[log(var_data(:,2)) log(var_data(:,4))] ;
data = [data(:,1)-hpfilter(data(:,1),100) data(:,2)-hpfilter(data(:,2),100)];    
     elseif (i==2)
 data=[log(var_data(2:rows(var_data),2)) log(var_data(1:rows(var_data)-1,4))] ;
 data = [data(:,1)-hpfilter(data(:,1),100) data(:,2)-hpfilter(data(:,2),100)];    
     else
 data=[log(var_data(1:rows(var_data)-1,2)) log(var_data(2:rows(var_data),4))] ;
 data = [data(:,1)-hpfilter(data(:,1),100) data(:,2)-hpfilter(data(:,2),100)];    
     end


 

Ndata = rows(data);
 
% compute some sample moments

m1 = mean(data(:,1)); % sample mean for variable 1
m2 = mean(data(:,2)); % sample mean for variable 2
m12 = mean(data(:,2).*data(:,1)); % sample mean of cross 
                                  % product between variables 1 and 2
m11 = mean(data(:,1).^2); % second moment variable 1
m22 = mean(data(:,2).^2); % second moment variable 2 
 
if (i==1)
disp('Corr(SP_t,GDP_t)')
elseif (i==2)
disp('Corr(SP_t-1,GDP_t)') 
else
disp('Corr(SP_t+1,GDP_t)') 
end

    std_gmm_corr
    
    
end

% Now compute the ratio of volatilities
data=[log(var_data(:,2)) log(var_data(:,4))] ;
data = [data(:,1)-hpfilter(data(:,1),100) data(:,2)-hpfilter(data(:,2),100)];    
Ndata = rows(data);
ratiostd_gmm

 